<?php
if ( wp_using_ext_object_cache() || !session_id() ) {
session_start();
if (!defined('WAFFIREWALL_SESS_STARTED')) {
    define('WAFFIREWALL_SESS_STARTED', true);
}    
}
if (!defined('ABSPATH')) exit;
/**
 * GP Firewall plugin for WordPress
 * @version     1.0.2
 * @license     Copyright 2024 Genius Plugin, Corp. © All Rights Reserved
 **/
if (defined('WAFFIREWALL_DISABLED') || !defined('WAFFIREWALL_V')) {
    exit;
}
// Dashboard add widget function
function waffirewall_dashboard_widgets()
{
    wp_add_dashboard_widget('waffirewall_dashboard_welcome', esc_html__('Waf Firewall Snapshot', 'gp-firewall'), 'waffirewall_welcome_widget');
    // Globalize the metaboxes array, this holds all the widgets for wp-admin.
    global $wp_meta_boxes;

    // Get the regular dashboard widgets array 
    // (which already has our new widget but appended at the end).
    $default_dashboard = $wp_meta_boxes['dashboard']['normal']['core'];

    // Backup and delete our new dashboard widget from the end of the array.
    $waffirewall_dashboard_widget_backup = array('waffirewall_dashboard_welcome' => $default_dashboard['waffirewall_dashboard_welcome']);
    unset($default_dashboard['waffirewall_dashboard_welcome']);

    // Merge the two arrays together so our widget is at the beginning.
    $sorted_dashboard = array_merge($waffirewall_dashboard_widget_backup, $default_dashboard);

    // Save the sorted array back into the original metaboxes. 
    $wp_meta_boxes['dashboard']['normal']['core'] = $sorted_dashboard;
}

// Callback widget's function
function waffirewall_welcome_widget()
{
    // Get the plugin options
    $settings = get_option('_waffirewall');
    // Display the widget map content if plugin is "fully" active 
    if (isset($settings['waffirewall_TOKEN']) && !empty($settings['waffirewall_TOKEN'])) {
?>
        <div style="height:300px;overflow:hidden !important"><iframe style="width:100%;height:400px;" src="<?php echo esc_url($settings['waffirewall_HUB'] . '/noc-r.php?app=w&token=' . $settings['waffirewall_TOKEN']); ?>" sandbox="allow-same-origin allow-scripts"></iframe></div>
<?php

        $topbar = new WAFFIREWALL_SettingsPage();
        $wafCheck = json_decode($topbar->waffirewall_check_license($settings['waffirewall_TOKEN']), true);

        // Notify user if asked for by the plugin.
        if (isset($wafCheck[4]) && $wafCheck[4] == 1) {
            // Dashboard notifier once per session, n times remotely
            if (!isset($_SESSION['WAFFIREWALL_DASHBOARD_NOTIFIER']) || $_SESSION['WAFFIREWALL_DASHBOARD_NOTIFIER'] != gmdate('Ymd')) {
                $_SESSION['WAFFIREWALL_DASHBOARD_NOTIFIER'] = gmdate('Ymd');
                add_action('admin_notices', $topbar->waffirewall_notify_user(1));
            }
        }
    }
}

// Launch the widget @ dashboard_setup hook
add_action('wp_dashboard_setup', 'waffirewall_dashboard_widgets');
